/*= ====================================================================================
 *  Meteo - displej cast
 *==================================================================================================

74164 mapa:
QA - IN0
QB - IN1
QC - IN2
QD - IN3
QE - DS1
QF - DS2
QG - DEST2
QH - DEST1

Nordic Map

P00 - TLLEV (in)
P01 - TLPRAV (in)
P02
P03 - CS1       =1
P04 - CS2 = 2
P05 - CS3    = 3
P06 - CLK
P07 - ser data

Veliciny

Teplota
-40.0 (-400 v sw)
az
123.8 (1238 v sw)

Vlhkost
0 (0 v sw)
100.0 (1000 v sw)

Tlak

650.3 (6503 v sw)
az
1200	(12000 v sw)
 

2.7V min = 3021 pro 12bit ADC a int REF

*/

#define NRF9E5 1


#include "reg9e5.h"
#include "stdio.h"
//#define POWER      0                // 0=min power...3 = max power
#define HFREQ      0                // 0=433MHz, 1=868/915MHz
#define CHANNEL  115                // Channel number: f(MHz) = (422.4+CHANNEL/10)*(1+HFREQ)  433.9MHz (pro 115ku)
/*
433.2 - 108
433.7 - 113
434.2 - 118
434.7 - 123
*/


#define TIMEOUT    20               // 20ms time-out on LED
#define ON          1
#define OFF         0

#define VOLTSPY	2182					//1.95V pro 12 bit res a samo mereni


static volatile unsigned char t0lrel, t0hrel;


sbit TLLEV = P0 ^ 0;
sbit TLPRAV = P0 ^ 1;
sbit CS1 = P0 ^ 3;
sbit CS3 = P0 ^ 5;			
sbit CS2 = P0 ^ 4;			
sbit CLK = P0 ^ 6;
sbit SDATA = P0 ^ 7;



unsigned char tmp,i, Slovo, Port, Citadlo, Service, Prijem, POW, NapajeniTX;
unsigned long int Tick;
unsigned char buf[6];// = {0,1,2,3,4,5};
unsigned int Teplota, Vlhkost, Tlak;
unsigned int Napajeni;

void Delay100us(volatile unsigned char n)        //ceka cca 100us
{
    unsigned char i;
    while(n--)
    for(i=0;i<35;i++);
}


unsigned char SpiReadWrite(unsigned char b)			//zapis do SPI
{
    EXIF &= ~0x20;                  // Clear SPI interrupt
    SPI_DATA = b;                   // Move byte to send to SPI data register
    while((EXIF & 0x20) == 0x00)    // Wait until SPI hs finished transmitting
        ;
    return SPI_DATA;
}

void Hc164_driver (unsigned char CoSviti)		//ridi 74164 displej
{
unsigned char xy;

	CLK = 0;
		
	for (xy = 0; xy <8; xy++)
	{
		if ((CoSviti & 0x80) == 0x80) SDATA = 1;
		else SDATA = 0;               
		_nop_();
		CLK = 1;
		_nop_();
		CLK = 0;
		CoSviti = (CoSviti << 1);	
	}
}

void ReceivePacket(unsigned long int KolikCekat)						//prijme 4 pakety (8 bajtu) z TXu, zaroven tam bezi timeout
{
   
	TXEN = 0; 
   TRX_CE = 1;
   if (KolikCekat == 0)
   {
   	 while((DR == 0));
   }
   else
   {
    	while((DR == 0) & (Tick < KolikCekat));
   }
   if ((Tick < KolikCekat) | (KolikCekat == 0))			//nebyl to timeout nebo se ceka furt
   {
   	RACSN = 0;
	   SpiReadWrite(RRP);
		Teplota = SpiReadWrite(0);   				//prvni prijaty bajt HI
		Teplota = (Teplota << 8) + SpiReadWrite(0);
		Vlhkost = SpiReadWrite(0);   			
		Vlhkost = (Vlhkost << 8) + SpiReadWrite(0);   			
 		Tlak = SpiReadWrite(0);
 		Tlak = (Tlak << 8) + SpiReadWrite(0);
	 	NapajeniTX = SpiReadWrite(0);				//servisni int
	 	Service = SpiReadWrite(0);
		RACSN = 1;
		Prijem = 1;		//neco prislo
	}
	else Prijem = 0;

//	Tick = 0;	
   TRX_CE = 0;

}

void TransmitPacket(void)				// posle, co ma
{
	
	TXEN = 1;
    RACSN = 0;
    SpiReadWrite(WTP);
    SpiReadWrite(0xAA);				//posilam 2 bajty
    SpiReadWrite(00);		

    RACSN = 1;
    TRX_CE = 1;
    Delay100us(1);
    TRX_CE = 0;
    while(DR == 0);				//ceka, az se to posle
}


void InitTimer(void)
{
    TR0 = 0;
    TMOD &= ~0x03;
    TMOD |= 0x01;                   // mode 1
    CKCON |= 0x08;                  // T0M = 1 (/4 timer clock)
    t0lrel = 0x17;                  // 1KHz tick...
    t0hrel = 0xFC;                  // ... = 65536-4e6/(4*1e3) = FC17h
    TF0 = 0;                        // Clear any pending Timer0 interrupts
    ET0 = 1;                        // Enable Timer0 interrupt
}

void Timer0ISR (void) interrupt 1
{
    TF0 = 0;                        // Clear Timer0 interrupt
    TH0 = t0hrel;                   // Reload Timer0 high byte
    TL0 = t0lrel;                   // Reload Timer0 low byte
    Tick++;
}


unsigned int Mer_1_kanal(unsigned char Kanal)       //meri jeden kanal ADC
{
unsigned char x, tlo, thi;
unsigned long vysledek = 0;

		for (x = 0; x <64; x++)                //delame 8 samplu
		{
        RACSN = 0;			        // Start ADC conversion na danem kanale
        SpiReadWrite(SAV  | Kanal);
        RACSN = 1;

        while(EOC == 0);			        // Wait until ADC conversion completes

        RACSN = 0;			        // Read Out ADC Value
        SpiReadWrite(RAD);
        tlo = SpiReadWrite(NOP);  //lo byte
        thi = SpiReadWrite(NOP);
        vysledek = vysledek + ((thi << 8) + tlo);
        RACSN = 1;
		}

	return(vysledek/64);
}


void Kalibruj_tick (void)						// pro 4kHz musi vychazet 1000 pro 8MHz xtal, 500 pro 4MHz
{
unsigned int per, h, per2;
unsigned int vysl;

	T2CON = 0x0D;			// nastaveni capture   1101 (exen2, tr2, c/t2, cp/rl2)
	TR2 = 0;
	TH2 = 0;
	TL2 = 0;
	TR2 = 1;
	T2CON = (T2CON & 0xBF); //smazne priznak	

	while ((T2CON & 0x40) == 0);
	per = (RCAP2H << 8) + RCAP2L;
	T2CON = (T2CON & 0xBF); //smazne priznak	
	while ((T2CON & 0x40) == 0);
	per2 = (RCAP2H << 8) + RCAP2L;
	vysl = (per2 - per);
/*
	if (vysl > 600) TICK_DV = 0x02;			//kalibrace
	if ((vysl > 375) & (vysl < 450)) TICK_DV = 0x04;			//kalibrace			
	if (vysl <= 375) TICK_DV = 0x05;			//kalibrace			
*/

		if (vysl > 1200) TICK_DV = 0x02;			//kalibrace
		if ((vysl > 750) & (vysl < 900)) TICK_DV = 0x04;			//kalibrace			
		if (vysl <= 750) TICK_DV = 0x05;			//kalibrace			
		

/* 
- musi se udelat kalibrace v v TICK_DV
- Ttick = (1+hodnota)/fCLK
900-1100 je ok
1200 az 1400 dat hodnotu 2 (tzn +1 = 3)
800 - 900 - dat 4ku (tj 5)
pod 750 tak dat 5ku 

54 = 1516
51 = 1478
45 = 1400
42 = 1363
36 = 1304
30 = 1265

10 = 1186
6st = 1160
-5 = 1130
-9 = 1108
-11 = 1080
-12.6 = 1064
-14.2 1045

*/
}

void Drive7211 (unsigned char DisplejNum)
{
unsigned char x;

//data se musi predat v nejakem bufferu, primo ascii
// 00 >> prvni cislo. 11 >> ctvrte cislo
	
	for (x = 0; x <4; x++)		//poslem 4 cisla
	{
		if (DisplejNum == 1) CS1 = 0;		//chip sel do nuly
		if (DisplejNum == 2) CS2 = 0;		//chip sel do nuly
		if (DisplejNum == 3) CS3 = 0;		//chip sel do nuly
		Slovo = (Slovo & 0xC0);
		Slovo = (Slovo | (buf[x]));	//da do nej data cisla k zobrazeni
		Slovo = (Slovo | (x << 4));
		Hc164_driver(Slovo);		//posli to na displej
		if (DisplejNum == 1) CS1 = 1;		
		if (DisplejNum == 2) CS2 = 1;		
		if (DisplejNum == 3) CS3 = 1;		
	}

/*
QA - IN0
QB - IN1
QC - IN2
QD - IN3
QE - DS1
QF - DS2
QG - DEST2
QH - DEST1

*/

}

void PrevodBCD(int CoTisknout)
{
//vystup je v buf[] poli
// buf0 je cislo uplne vpravo
// buf3 je uplne vlevo
// buff4 je des tecka
	
unsigned char i,j, minus=0;

	i = 0;
	if (CoTisknout < 0)				//ok, udela se jen korekce znamenka
	{
		minus = 1;
		CoTisknout = CoTisknout * -1;
	}

	
	for (j = 0; j < 4; j++)
	{
		buf[i] = (CoTisknout % 10);
		i++;
		CoTisknout	= CoTisknout/ 10;
	}
  
  if (buf[3] == 0) buf[3] = 0xFF;	//zhasne nuly
  
   if (minus == 1)
   {
   		buf[3] = 0x0A;		//0x0A je kod pro minus
   }
//   else buf[3] = 0;

	buf[4] = 1;		//default zapnuta des tecka
}

void PowerSet(void)
{


	POW = 3;
    RACSN = 0;
    SpiReadWrite(WRC);              // Write RF config address 0
    SpiReadWrite(CHANNEL & 0xff);   // CHANNEL bit7..0
    // Change power defined by POWER above, to 433 or 868/915MHz defined by HFREQ and
    // bit8 of CHANNEL:
    SpiReadWrite(tmp | (POW<<2) | (HFREQ << 1) | ((CHANNEL >> 8) & 0x01));
    RACSN = 1;
}



void InitADC(unsigned char Akce)
{
    // Configure and turn on ADC
    RACSN = 0;
    SpiReadWrite(WAC);              // Write to ADC config
	 if (Akce == 1) SpiReadWrite(0x35);             // Select AIN3, PWR_UP = 1, VFSEL=0 (externi);
	 else SpiReadWrite(0x31) ;						//vypni ADC
    SpiReadWrite(0x0B);             // Set RES_CTRL = 3, Right justified, 12 bitu
    RACSN = 1;
}

void Init(void)
{
//DIR = 0 >>> OUT

    P0_DIR = 0x03;                  // viz uvod
	P0_ALT |= 0x00;     // zadna alt fce
//    P0_ALT |= 0x04;     // TXD nastav - pro seriovku
//	P0_DRV = 0x08;			//P0.4 dava proud pro optoclen
//    P0_DIR |= 0x02;     // P0.1 (RxD) is input
  
  
    SPICLK = 1;
    SPI_CTRL = 0x02;                // Connect internal SPI controller to Radio
    
    TH1 = 243;          // 9600@8MHz (when T1M=1 and SMOD=1)
    CKCON |= 0x30;      // T1M=1 (/4 timer clock) a TIM2 to same
    PCON = 0x80;        // SMOD=1 (double baud rate)
    SCON = 0x52;        // Serial mode1, enable 
    TMOD = 0x20;        // Timer1 8bit auto reload 
//    TR1 = 1;            // Start timer1
    
	CKLFCON = 0xCF; 				//5-3X OFF, 2, XO_DIRECT, 1-0 UPCLKFREQ   00 000 0 00

    // Switch to 4/8MHz clock:
    RACSN = 0;
    SpiReadWrite(RRC | 0x09);
    tmp = SpiReadWrite(0) | 0x04;						//1110 0111 je default, ma byt 1100 1111
    RACSN = 1;

    RACSN = 0;
    SpiReadWrite(WRC | 0x09);			// 9. bajt
//    SpiReadWrite(0xC0);				
    SpiReadWrite(0xCF);				// 8MHz
//    SpiReadWrite(0xC7);				// 4MHz
    RACSN = 1;

    // Configure Radio:
    RACSN = 0;
    SpiReadWrite(WRC | 0x03);       // Write to RF config address 3 (RX payload)
    SpiReadWrite(0x08);             // 8 byte RX payload
    SpiReadWrite(0x02);             // 2 byte TX payload
    RACSN = 1;

    RACSN = 0;
    SpiReadWrite(RRC | 0x01);       // Read RF config address 1
    tmp = SpiReadWrite(0) & 0xf0;   // Clear the power and frequency setting bits
    RACSN = 1;

    InitTimer();
    EA = 1;
}

void main(void)
{
//	PrevodBCD(-123);


	Init();


	InitADC(0);
	PowerSet();				//nastavi vykon
	
//	Kalibruj_tick();
	TR0 = 1;						// zapne timer

//	Teplota = -128;
//	Vlhkost = 768;
//	Tlak = 1017;

	buf[0] = 0x0A;
	buf[1] = 0x0A;
	buf[2] = 0x0A;
	buf[3] = 0x0A;			//carky

	Drive7211(1);
	Drive7211(2);
	Drive7211(3);
	Delay100us(20);

	while(1)
	{
		buf[0] = 0x0E;
		buf[1] = 0x0F;
		buf[2] = 0x0F;
		buf[3] = 0x0F;			//BL  

		Drive7211(3);

		InitADC(1);
		Delay100us(20);
		Napajeni = Mer_1_kanal (8);
		Slovo = Mer_1_kanal (1);
		Delay100us(50);
		InitADC(0);

		Prijem = 0;
		Tick = 0;
		ReceivePacket(0);		//pokud je cas 0, ceka furt
		if (Prijem == 1)
		{
			PrevodBCD(Teplota);
			Slovo = (Slovo | 0x80);		//des tecka
			Drive7211(1);				//pis na displej
			PrevodBCD(Vlhkost);
			Slovo = (Slovo | 0x40);		//des tecka
			Drive7211(2);
			PrevodBCD(Tlak);
			Drive7211(3);	

			if (NapajeniTX < 180)			//baterky jsou ko
			{
				buf[0] = 0x08;
				buf[1] = 0x0D;
				buf[2] = 0x0F;
				buf[3] = 0x0F;			//BL  

				Drive7211(3);
			}

		}


//		Kalibruj_tick();
		while ((REGX_CTRL & 0x10) != 0);			//cekej, az se ten reg uvolni
		REGX_MSB = 0x00;							//cas idle cca 55 sec
		REGX_LSB = 0x02;
		REGX_CTRL = 0x09;						// zapis to do RTC registru, pis 3 bajt rtc
		while ((REGX_CTRL & 0x10) != 0);			//cekej, az se ten reg uvolni - podle datasheetu

		REGX_MSB = 0xB3;							//cas idle cca 177 sec (o 3sec mene nez TX)
		REGX_LSB = 0x68;
		REGX_CTRL = 0x0A;						// zapis to do RTC registru
		while ((REGX_CTRL & 0x10) != 0);			//cekej, az se ten reg uvolni - podle datasheetu



//		CK_CTRL = 0x04;						// power down?
		CK_CTRL = 0x02;						// moderate PD

// *********** tady se probudil
		while ((REGX_CTRL & 0x10) != 0);			//cekej, az se ten reg uvolni
		REGX_CTRL = 0x0B;						// zakaz RTC WRTCDIS


	}

}

